commit 04912cbb0b452625800be1afd7f23f859e7288f2
Author: Andrew Stubbs <ams@codesourcery.com>
Date:   Thu Sep 10 10:10:32 2020 +0100

    amdgcn: align TImode registers
    
    This prevents execution failures caused by partially overlapping input and
    output registers.  This is the same solution already used for DImode.
    
    gcc/ChangeLog:
    
            * config/gcn/gcn.c (gcn_hard_regno_mode_ok): Align TImode registers.
            * config/gcn/gcn.md: Assert that TImode registers do not early clobber.
    
    (cherry picked from commit 8ae0de5621120b16295fe6b73ca044d4c576af6d)

diff --git a/gcc/config/gcn/gcn.c b/gcc/config/gcn/gcn.c
index 39eb8fd283f..c7c057f73cc 100644
--- a/gcc/config/gcn/gcn.c
+++ b/gcc/config/gcn/gcn.c
@@ -468,7 +468,8 @@ gcn_hard_regno_mode_ok (unsigned int regno, machine_mode mode)
     return (vgpr_1reg_mode_p (mode)
 	    || (!((regno - FIRST_VGPR_REG) & 1) && vgpr_2reg_mode_p (mode))
 	    /* TImode is used by DImode compare_and_swap.  */
-	    || mode == TImode);
+	    || (mode == TImode
+		&& !((regno - FIRST_VGPR_REG) & 3)));
   return false;
 }
 
